﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using dlytmusic.ViewModel;
using dlytmusic.Dbugns;

using System.Windows.Threading;
//using System.Text.RegularExpressions;

namespace dlytmusic {
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window {

        public static MainWindowVM mwinVM;
        public static MainWindow mwin;


        public MainWindow(MainWindowVM windowVM) {
            InitializeComponent();
            this.DataContext = windowVM;

            #region trata paste no url
            
            DataObject.AddPastingHandler(textBox_URL, new DataObjectPastingEventHandler(OnPaste));
            
            #endregion trata paste no url


            mwin = this;
            mwinVM = windowVM;

            EventHandler onActivatedCheckClipboard = null;
            onActivatedCheckClipboard = (o, e) => {
                //this.Activated -= onActivatedCheckClipboard;
                this.checkClipBoard();
            };
            this.Activated += onActivatedCheckClipboard;
        }

        private void checkClipBoard() {
            if (Clipboard.ContainsText()) {
                string cliptext = Clipboard.GetText();
                if (SetupItem.okUrl(cliptext)) {
                    mwinVM.setupitem.URL = SetupItem.trimUrl(cliptext);
                    mwinVM.setupitem.RaisePropertyChangedP("URL");
                    if (mwin.textBox_URL.Focus()) {
                        mwin.textBox_URL.SelectAll();
                    }
                }
            }
        }

        #region trata paste no url
        
        private void OnPaste(object sender, DataObjectPastingEventArgs e){
            bool isText = e.SourceDataObject.GetDataPresent(System.Windows.DataFormats.Text, true);
            if (!isText) return;
            string text = e.SourceDataObject.GetData(DataFormats.Text) as string;
            mwinVM.setupitem.URL = SetupItem.trimUrl(text);
            mwinVM.setupitem.RaisePropertyChangedP("URL");
            if (mwin.textBox_URL.Focus()) {
                mwin.textBox_URL.SelectAll();
            }
            
            Application.Current.Dispatcher.BeginInvoke(DispatcherPriority.Normal, (Action)(() => {
                if (!SetupItem.okUrl(text)) {
                    System.Windows.MessageBox.Show("That URL is invalid.");
                }
            }));

            //e.Handled = true;
            e.CancelCommand();
            
            

        }
        
        #endregion trata paste no url

        //private void button_add_to_cue_Click(object sender, RoutedEventArgs e) {
        //    Dbug.wline(": {0}", mwinVM.setupitem.toString());
        //}
    }
}
