﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using dlytmusic.DataAccess;
namespace dlytmusic {
    /// <summary>
    /// Changed startup object in properties to this
    /// </summary>
    public class Program {
        [STAThreadAttribute]
        public static void Main(string[] args) {


            if (dropSomeFiles()) {
                App.Main();
            } else {
                System.Windows.MessageBox.Show("This program needs write access to its instalation folder.");
            }
        }


        public static void SaveResourceToDisk(string ResourceName, string FileToExtractTo) {
            if (!File.Exists(FileToExtractTo)) {
                using (Stream s = System.Reflection.Assembly.GetExecutingAssembly().GetManifestResourceStream(ResourceName)) {
                    using (FileStream resourceFile = new FileStream(FileToExtractTo, FileMode.Create)) {
                        byte[] b = new byte[s.Length + 1];
                        s.Read(b, 0, Convert.ToInt32(s.Length));
                        resourceFile.Write(b, 0, Convert.ToInt32(b.Length - 1));
                    }
                }
            }
        }

        private static void SaveResToDisk(string dllname, string namespacePath, string libraryDirectory) {
            SaveResourceToDisk(string.Format("{0}.{1}", namespacePath, dllname), Path.Combine(libraryDirectory, dllname));
        }

        private static bool dropSomeFiles() {
            //string libraryDirectory = FileAPI.appdataSubDir; //FileAPI.getAppDataSubDir();
            string libraryDirectory = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetEntryAssembly().Location); //exec folder
            if (!FileSys.hasWriteAccessToFolder(libraryDirectory)) {
                return false;
            }
            string namespacePath = "dlytmusic.Resources";
            SaveResToDisk("ffmpeg.exe", namespacePath, libraryDirectory);
            SaveResToDisk("ffplay.exe", namespacePath, libraryDirectory);
            SaveResToDisk("ffprobe.exe", namespacePath, libraryDirectory);
            SaveResToDisk("youtube-dl.exe", namespacePath, libraryDirectory);//https://yt-dl.org/downloads/2013.11.17/youtube-dl.exe
            return true;
        }
        



    }
}
