﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.ComponentModel;
using dlytmusic.Dbugns;

using System.Diagnostics;
//using System.Windows.Input;
//using System.Windows;
//using System.Threading;
using System.Collections.ObjectModel;

using dlytmusic.DataAccess;

namespace dlytmusic.ViewModel {
    public class MainWindowVM : ViewModelBase, INotifyPropertyChanged {

        public static MainWindowVM mwinVM;
        public static MainWindow mwin;
        
        public MainWindowVM() {
            setupitem = new SetupItem();

            setupitem.validateSetup();
            //RaisePropertyChanged("setupitem");

            dlitems = new ObservableCollection<DLitem>();

        }



        public ObservableCollection<DLitem> dlitems { get; set; }




        public SetupItem setupitem { get; set; }

        public RelayCommand AddCmd {
            get {
                return new RelayCommand(cmdparam => {
                    //Dbug.wline("Command ({0}) text is {1}", cmdparam, Organization);
                    Dbug.wline("-----------------------------\r\nAdding: {0}", setupitem.toString());
                    addcmd();
                });
            }
        }

        private void addcmd() {
            if(!SetupItem.okUrl(setupitem.URL)){
                System.Windows.MessageBox.Show("The URL address is invalid. \n\rPlease correct it and try again.");
                return;
            }
            if (!Directory.Exists(setupitem.Folder)) {
                System.Windows.MessageBox.Show("That folder does not exist. \n\rPlease correct it and try again.");
                return;
            }
            if (!FileSys.hasWriteAccessToFolder(setupitem.Folder)) {
                System.Windows.MessageBox.Show("Cannot write to that folder. \n\rPlease change it and try again.");
                return;
            }
            DLitem newitem = new DLitem(this) {
                Filename = setupitem.Filename,
                Folder = setupitem.Folder,
                Formato = setupitem.Formato,
                Qualidade = setupitem.Qualidade,
                Prioridade = setupitem.Prioridade,
                URL = setupitem.URL
            };
            newitem.DownloadEndsEvt += dlitemEnds;

            foreach (DLitem dli in dlitems) {
                if (dli.Filename == newitem.Filename && dli.Folder == newitem.Folder && SetupItem.getCode(dli.URL) == SetupItem.getCode(newitem.URL)) {
                    System.Windows.MessageBox.Show("That item is already in queue.");
                    return;
                }
            }

            newitem.findTitle();
            dlitems.Add(newitem);
            RaisePropertyChanged("dlitems");

            checkForNewDL();
        }

        public void removeDlitem(DLitem dli) {
            dlitems.Remove(dli);
        }

        public void dlitemEnds(DLitem src, DownloadEndsEventArgs ea) {
            Dbug.wline("dlitemEnds: {0}", src.URL);
            //...
            checkForNewDL();
        }

        public void checkForNewDL() {
            foreach (DLitem dli in dlitems) {
                if (dli.isBusy()) {
                    return;
                }
            }
            foreach (DLitem dli in dlitems) {
                if (dli.Prioridade == "1" && dli.State == DownloadState.Waiting) {
                    dli.startDLOperation();
                    return;
                }
            }
            foreach (DLitem dli in dlitems) {
                if (dli.Prioridade == "2" && dli.State == DownloadState.Waiting) {
                    dli.startDLOperation();
                    return;
                }
            }
            foreach (DLitem dli in dlitems) {
                if (dli.Prioridade == "3" && dli.State == DownloadState.Waiting) {
                    dli.startDLOperation();
                    return;
                }
            }
        }
        //-------------------------------------------------------------------------------------------

        #region INotifyPropertyChanged
        public new event PropertyChangedEventHandler PropertyChanged; //overridden base class with new
        protected virtual void OnPropertyChanged(PropertyChangedEventArgs e) {
            if (PropertyChanged != null) {
                PropertyChanged(this, e);
                Dbug.wline("raised " + e.PropertyName);
            }
        }

        protected void RaisePropertyChanged(string propertyName) {
            OnPropertyChanged(new PropertyChangedEventArgs(propertyName));
        }

        public void RaisePropertyChangedP(string propertyName) {
            RaisePropertyChanged(propertyName);
        }

        #endregion
    }
}
